#line 224 "/home/dodo/SFP/zooming_stickies-1.0/src/bgclip.u"
#include <stdlib.h>
#include <string.h>
#include "bgclip.h"

#line 6 "bgclip.c"

static int subtract_rectangle(int *B, int *O, int *diff);
#line 133 "/home/dodo/SFP/zooming_stickies-1.0/src/bgclip.u"

static int subtract_rectangle(int *B, int *O, int *diff)
{
  int Ol,Or,Ot,Ob;
  int Bl,Br,Bt,Bb;
  int n;

  Ol= O[0]; Ot= O[1]; Or= O[2]; Ob= O[3];
  Bl= B[0]; Bt= B[1]; Br= B[2]; Bb= B[3];

// First, we check for the no-intersection case
  if (Ol>Br || Or<Bl || Ot>Bb || Ob<Bt) return 0;

// Now we clip the object to the intersection of O and B.
// We're not interested in the difference O - B. 

  if (Ol<Bl) Ol= Bl;
  if (Or>Br) Or= Br;
  if (Ot<Bt) Ot= Bt;
  if (Ob>Bb) Ob= Bb;

  n= 0;
// We assume that the object lies in the middle of the background.
// We try to generate the corresponding areas, but don't do it
// if the area has zero dimension in width or height.
// As we extract the regions, we also collapse the background so
// that the remaining rules don't generate overlapping areas.

  if (Ot>Bt) { diff[n++]= Bl; diff[n++]= Bt; diff[n++]= Br; diff[n++]= Ot;
               Bt= Ot; }
  if (Ob<Bb) { diff[n++]= Bl; diff[n++]= Ob; diff[n++]= Br; diff[n++]= Bb;
               Bb= Ob; }
  if (Ol>Bl) { diff[n++]= Bl; diff[n++]= Bt; diff[n++]= Ol; diff[n++]= Bb;
               Bl= Ol; }
  if (Or<Br) { diff[n++]= Or; diff[n++]= Bt; diff[n++]= Br; diff[n++]= Bb; 
               Br= Or; }

// If n is 0, then the two rectangles must be coincident.

  if (n==0) return -1;
  return n/4;
}

#line 56 "/home/dodo/SFP/zooming_stickies-1.0/src/bgclip.u"

bgclip_t *bgclip_start(size_t initial, int L,int T,int R,int B)
{
  bgclip_t *C;

    // to make the *=4 correct, below
  if (initial<20) initial= 20;
  C= malloc(sizeof(*C));
  C->size= initial*4;
  C->len= 0;
  C->data= malloc(sizeof(int)*C->size);
  C->data[C->len++]= L;
  C->data[C->len++]= T;
  C->data[C->len++]= R;
  C->data[C->len++]= B;
  return C;
}

void bgclip_remove(bgclip_t* C,int L, int T,int R, int B)
{
  int i;
  int sub[4*4],n;
  int O[4];
  int len;

  O[0]= L; O[1]= T; O[2]= R; O[3]= B;
  len= C->len;
 
  for(i=0;i<len && i<C->len;i+=4)
  {
     n= subtract_rectangle(C->data+i, O, sub);
     if (n==0) continue; // no intersection, no change
     if (n==-1)          // the whole thing was removed
     {
        memcpy(C->data+i, C->data+C->len-4, sizeof(int)*4);
        C->len -= 4;
        i-= 4;
        continue;
     }
     memcpy(C->data+i, sub, sizeof(int)*4);
     n--;
     if (n==0) continue;
     if (C->len+n*4>C->size)
     {
        C->size*= 4;
        C->data= realloc(C->data, C->size*sizeof(int));
     }
     memcpy(C->data+C->len, sub+4, sizeof(int)*n*4);
     C->len+= n*4;
  }
}
#line 185 "/home/dodo/SFP/zooming_stickies-1.0/src/bgclip.u"

int bgclip_get(bgclip_t *C, int *L,int *T,int *R, int *B)
{
  if (C->len==0) return 0;
  *B= C->data[--C->len];
  *R= C->data[--C->len];
  *T= C->data[--C->len];
  *L= C->data[--C->len];
  return 1;
}

void bgclip_free(bgclip_t *C)
{
  free(C->data);
  free(C);
}

#line 233 "/home/dodo/SFP/zooming_stickies-1.0/src/bgclip.u"

