#line 9 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

#ifndef GRAPHVIEW_H_INCLUDED
#define GRAPHVIEW_H_INCLUDED

#ifndef FXSCROLLARAEA_H
#include <FXComposite.h>
#include <FXTextField.h>
#include <FXVerticalFrame.h>
#include <FXHorizontalFrame.h>
#include <FXText.h>
#include <FXButton.h>
#include "panarea.h"
#include "bgclip.h"
#include <map>
#endif

namespace FX {

#line 175 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

typedef struct {
  int left, top, right, bottom;
  int font_size;
  char *text;
  int text_x, text_y_baseline;
  char **rows;
  FXColor color;
} box_t;

#line 28 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
	
class FXAPI GraphView : public FXComposite {
	FXDECLARE(GraphView)
protected:
	GraphView();
private:
	GraphView(const GraphView&);
	GraphView &operator=(const GraphView&);
public:
	long onPaint(FXObject*,FXSelector,void*);

	GraphView(FXComposite* p, FXObject *tgt=NULL, int sel= 0,
		FXuint opts=FRAME_NORMAL,
		FXint x=0,FXint y=0,FXint w=0,FXint h=0);
	virtual ~GraphView();

	virtual bool canFocus() const;
	virtual void create();
	virtual void detach();
        virtual void layout();

	virtual int getDefaultWidth();
	virtual int getDefaultHeight();

#line 210 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  int n_boxes, s_boxes;
  box_t **boxes;

#line 230 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  double shik;

#line 243 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void screen_coords(int doc_x, int doc_y, int *scr_x,int *scr_y) ;
void document_coords(int scr_x, int scr_y, int *doc_x, int *doc_y);

#line 326 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  void draw_box(FXDCWindow *dc, box_t *box);

#line 389 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void zoom_in();
void zoom_out();

#line 427 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
  FXFont *default_font;
  int default_font_height, default_font_space, default_font_ascent;

#line 445 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
  FXFont *make_font(double size);

#line 467 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

box_t* create_box(int x,int y, FXColor color, char *text);

#line 507 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  std::map<int, FXFont*> *font_map;

#line 520 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  FXFont *get_font(double size);

#line 546 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
  PanArea *scroller;

#line 552 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

 void zoom(double f,int x,int y);

#line 587 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

long onMouseWheel(FXObject* ob,FXSelector sel,void* ptr);

#line 613 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  int max_x, max_y, min_x, min_y;

#line 631 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void update_scroller();

#line 668 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

 void show_request(int x,int y);

#line 704 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

 void click_action(int x,int y);
 void doubleclick_action(int x,int y);


#line 726 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  box_t *dragging_box;

#line 374 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

 void mouse_release_action();

#line 711 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

int drag_start(int x,int y);

#line 737 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void motion_action(int old_x,int old_y, int x,int y);

#line 779 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

 void update_max_coords(box_t *B);

#line 802 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

 void pan_request(int dx,int dy);

#line 867 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
   box_t *find_box_screen(int x,int y);

#line 889 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

 box_t *selected_box;

#line 901 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  void draw_selection(FXDCWindow *dc);

#line 919 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  int box_visible(box_t *B);
  void box_screen_coords(box_t *B, int *X, int *Y, int *W, int *H);

#line 948 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void select_box(box_t *B);

#line 966 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  void update_box(box_t *B, int borders= FALSE);

#line 1011 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void set_box_color(box_t *B, FXColor color);

#line 1032 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

 FXVerticalFrame *text_frame;
 FXText *node_text;

#line 1059 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

 
long cancel_nodetext(FXObject* ob,FXSelector sel,void* ptr);
long ok_nodetext(FXObject* ob,FXSelector sel,void* ptr);


#line 1070 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void edit_text(box_t *B);

#line 1108 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  box_t *editing_box;

#line 1147 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void layout_text(box_t *box, int X,int Y);

#line 1213 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void set_text(box_t *box, char *text);

#line 1245 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

long nodetext_key(FXObject* ob,FXSelector sel,void* ptr);

#line 1266 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

 void remove_box(box_t *B);
#line 1300 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void parse_input(FILE *f, box_t ***Rboxes, int *Rnboxes, int *Rsboxes);

#line 1428 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void output_box(FILE *f,box_t *B);

#line 1460 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
 void output_chars(FILE *f, char *str, int len);
#line 1476 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
void load_file(FILE *f);
void save_file(FILE *f);
#line 1526 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  int modified;

#line 1538 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void clear_all();

#line 1567 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

 void rescale_box(box_t *B, double fact);

#line 16 "/home/dodo/SFP/zooming_stickies-1.0/src/mouse.u"

  long onLeftBtnPress(FXObject*,FXSelector,void*);
  long onLeftBtnRelease(FXObject*,FXSelector,void*);
  long onMotion(FXObject*,FXSelector,void*);
#line 24 "/home/dodo/SFP/zooming_stickies-1.0/src/mouse.u"

  int last_mouse_x, last_mouse_y;
  int click_mouse_x, click_mouse_y;
  int mouse_down;

#line 115 "/home/dodo/SFP/zooming_stickies-1.0/src/mouse.u"

 int dragging;

#line 54 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
        int pos_x, pos_y ; // transitioned to FXComposite instead.

        enum {
#line 839 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

   ID_DCLICK_SPACE,
   ID_DCLICK_NODE,
#line 987 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  ID_CLICK_NODE, ID_CLICK_SPACE,
 
#line 58 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
             ID_NODETEXT_OK, ID_NODETEXT_CANCEL, ID_NODETEXT,
           ID_LASTMESSAGE
        };

};

}

#endif


