
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <limits.h>
#include <fx.h>
#include <stdint.h>
#include <FXPNGIcon.h>

static int app_created;

#include "gui.h"


#line 2 "gui.fxf" 

#include <errno.h>
#include <stdio.h>
#include "graphview.h"
#include "panarea.h"
#include "iface.h"

static FXColor default_color= FXRGB(0xff,0x6b,0x8e);
static void color_button_click(GraphView* graph, FXButton* button)
{
  FXColor color;
  color= button->getBackColor();
  if (graph->selected_box) 
    graph->set_box_color(graph->selected_box, color);
  else
    default_color= color;
}

static char *file_name;

static void save_file(FXWindow *owner,GraphView *graph, FXLabel *status_bar)
{
     int new_fn= 0; char buf[2000];
     if (!file_name)
     {
       FXString fn;
       fn= "";
       do {
         fn= FXFileDialog::getSaveFilename(owner, "Save As", fn, "*.zsn");
         if (fn==FXString::null) return ;
       } while (FXStat::exists(fn) &&
           FXMessageBox::question(owner, MBOX_YES_NO,
                 "Overwrite file", "Overwrite existing file %s?",
                 fn.text())==MBOX_CLICKED_NO);
       file_name= strdup(fn.text());
       new_fn= 0;
     }
     FILE *f;
     f= fopen(file_name, "w");
     if (!f) {
       snprintf(buf,sizeof(buf)-1,
	    "Can't read %s: %s.", file_name, strerror(errno));
       status_bar->setText(buf);
       if (new_fn) { free(file_name); file_name=0; }
       return ;
     }
     graph->save_file(f);
     graph->modified= 0;
     fclose(f);
     snprintf(buf,sizeof(buf)-1,"File %s saved.", file_name);
     status_bar->setText(buf);
}

static void load_file(FXWindow *owner,GraphView *graph, FXLabel *status_bar)
{
     char buf[2000];
     if (graph->modified && FXMessageBox::question(owner, MBOX_YES_NO,
	     "Confirm discarding of edited contents",
	     "Current contents are not saved. Proceed with\n"
	     "loading a new file?")!=MBOX_CLICKED_YES) return ;
     FXString fn;
     fn= FXFileDialog::getOpenFilename(owner, "Open File", "", "*.zsn");
     if (fn==FXString::null) return ;
     FILE *f;
     f= fopen(fn.text(), "rb");
     if (!f)
     {
       snprintf(buf,sizeof(buf)-1,
	    "Can't read %s: %s.", fn.text(), strerror(errno));
       status_bar->setText(buf);
       return ;
     }
     graph->load_file(f);
     fclose(f);
     graph->modified= 0;
     if (file_name) free(file_name);
     file_name= strdup(fn.text());
     snprintf(buf,sizeof(buf)-1,"File %s loaded.", file_name);
     status_bar->setText(buf);
}

static void new_file(FXWindow *owner,GraphView *graph, FXLabel *status_bar)
{
   if (graph->modified && FXMessageBox::question(owner, MBOX_YES_NO,
      "Confirm discarding of edited contents",
      "Current contents are not saved. Proceed with\n"
      "creation of a new file?")!=MBOX_CLICKED_YES) return ;
   if (file_name) free(file_name);
   file_name= 0;
   graph->clear_all();
   graph->modified= 0;
}

static void save_file_as
  (FXWindow *owner,GraphView *graph, FXLabel *status_bar)
{
     char buf[2000];
     FXString fn;
     char *fname;
     fn= "";
     do {
       fn= FXFileDialog::getSaveFilename(owner, "Save As", fn, "*.zsn");
       if (fn==FXString::null) return ;
     } while (FXStat::exists(fn) &&
           FXMessageBox::question(owner, MBOX_YES_NO,
                 "Overwrite file", "Overwrite existing file %s?",
                 fn.text())==MBOX_CLICKED_NO);
     fname= strdup(fn.text());

     FILE *f;
     f= fopen(fname, "w");
     if (!f) {
       snprintf(buf,sizeof(buf)-1,
	    "Can't read %s: %s.", fname, strerror(errno));
       status_bar->setText(buf);
       free(fname);
       return ;
     }
     graph->save_file(f);
     graph->modified= 0;
     fclose(f);
     snprintf(buf,sizeof(buf)-1,"File %s saved.", fname);
     status_bar->setText(buf);
     if (file_name) free(file_name);
     file_name= fname;
}


#include "actions.h"



 

static void button_set_text(gui_button_t *B,const char *text)
{
  FXButton *W= (FXButton*) B->widget;
  W->setText(text);
}

static gui_button_class_t
 gui_button_class= {
  button_set_text,
};




static void label_set_text(gui_label_t *B, char *text)
{
  FXLabel *W= (FXLabel*) B->widget;
  W->setText(text);
}

static gui_label_class_t
 gui_label_class= {
  label_set_text,
};


  static FXFont *YQRZ_114;
    

static void tv_set_text
  (gui_text_viewer_t *TV, const char *v)
{
  FXText *T= (FXText*) (TV->widget);
  T->setText(v);
}

static void tv_clear
  (gui_text_viewer_t *TV)
{
  FXText *T= (FXText*) (TV->widget);
  T->removeText(0, T->getLength()); 
}

 static gui_text_viewer_class_t gui_text_viewer_class= 
 {
   tv_clear,
   tv_set_text,
 };


 
 
 

 class VFLL15: public FXMainWindow
 {
  FXDECLARE(VFLL15)
 public:
  enum { ID_FIRST= FXMainWindow::ID_LAST,
         ID_SELF,
         
   YQRZ_2,



VFLL3= YQRZ_2+
#line 148 "gui.fxf" 
 PanArea ::ID_LASTMESSAGE,



 YQRZ_4,


 YQRZ_9,


 YQRZ_14,


 YQRZ_20,


 YQRZ_25,


 YQRZ_30,


 YQRZ_36,


 YQRZ_41,


 YQRZ_46,


 YQRZ_53,


 YQRZ_59,


 YQRZ_64,


 YQRZ_71,


 YQRZ_76,


 YQRZ_82,


 YQRZ_87,


 YQRZ_94,


 YQRZ_99,


   YQRZ_106,



VFLL8= YQRZ_106+
#line 294 "gui.fxf" 
 GraphView ::ID_LASTMESSAGE,


 };
  

  
#line 148 "gui.fxf" 
 PanArea  *scroller;



long VFLL2(FXObject *object,FXSelector sel, void *arg);



long VFLL5(FXObject *object,FXSelector sel, void *arg);



  long YQRZ_7(FXObject *object,FXSelector sel, void *arg);
  FXButton *color0;



  long YQRZ_12(FXObject *object,FXSelector sel, void *arg);
  FXButton *color1;



  long YQRZ_17(FXObject *object,FXSelector sel, void *arg);
  FXButton *color2;



  long YQRZ_23(FXObject *object,FXSelector sel, void *arg);
  FXButton *color3;



  long YQRZ_28(FXObject *object,FXSelector sel, void *arg);
  FXButton *color4;



  long YQRZ_33(FXObject *object,FXSelector sel, void *arg);
  FXButton *color5;



  long YQRZ_39(FXObject *object,FXSelector sel, void *arg);
  FXButton *color6;



  long YQRZ_44(FXObject *object,FXSelector sel, void *arg);
  FXButton *color7;



  long YQRZ_49(FXObject *object,FXSelector sel, void *arg);
  FXButton *color8;



  long YQRZ_56(FXObject *object,FXSelector sel, void *arg);
  



  long YQRZ_62(FXObject *object,FXSelector sel, void *arg);
  



  long YQRZ_67(FXObject *object,FXSelector sel, void *arg);
  



  long YQRZ_74(FXObject *object,FXSelector sel, void *arg);
  



  long YQRZ_79(FXObject *object,FXSelector sel, void *arg);
  



  long YQRZ_85(FXObject *object,FXSelector sel, void *arg);
  



  long YQRZ_90(FXObject *object,FXSelector sel, void *arg);
  



  long YQRZ_97(FXObject *object,FXSelector sel, void *arg);
  



  long YQRZ_102(FXObject *object,FXSelector sel, void *arg);
  



  
#line 294 "gui.fxf" 
 GraphView  *graph;



long VFLL7(FXObject *object,FXSelector sel, void *arg);



long VFLL10(FXObject *object,FXSelector sel, void *arg);



long VFLL12(FXObject *object,FXSelector sel, void *arg);



long VFLL14(FXObject *object,FXSelector sel, void *arg);



  FXLabel *status_bar;


  VFLL15(FXApp* a,const FXString& name,
         FXIcon *ic,FXIcon *mi,FXuint opts,
         FXint x,FXint y,FXint w,FXint h,
         FXint pl,FXint pr,FXint pt,FXint pb,
         FXint hs,FXint vs);
  virtual ~VFLL15();
  VFLL15() : FXMainWindow() { }
  long handle_close(FXObject *object,FXSelector sel, void *arg);
 };

 FXDEFMAP(VFLL15) YQRZ_111 []= {
  FXMAPFUNC(SEL_CLOSE, VFLL15::ID_SELF, VFLL15::handle_close),
  
  FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_2 + 
#line 148 "gui.fxf" 
 PanArea ::ID_SHOWREQ,
                VFLL15::VFLL2),


  FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_2 + 
#line 148 "gui.fxf" 
 PanArea ::ID_PANREQ,
                VFLL15::VFLL5),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_4, VFLL15::YQRZ_7),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_9, VFLL15::YQRZ_12),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_14, VFLL15::YQRZ_17),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_20, VFLL15::YQRZ_23),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_25, VFLL15::YQRZ_28),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_30, VFLL15::YQRZ_33),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_36, VFLL15::YQRZ_39),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_41, VFLL15::YQRZ_44),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_46, VFLL15::YQRZ_49),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_53, VFLL15::YQRZ_56),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_59, VFLL15::YQRZ_62),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_64, VFLL15::YQRZ_67),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_71, VFLL15::YQRZ_74),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_76, VFLL15::YQRZ_79),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_82, VFLL15::YQRZ_85),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_87, VFLL15::YQRZ_90),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_94, VFLL15::YQRZ_97),


 
    FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_99, VFLL15::YQRZ_102),


  FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_106 + 
#line 294 "gui.fxf" 
 GraphView ::ID_DCLICK_SPACE,
                VFLL15::VFLL7),


  FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_106 + 
#line 294 "gui.fxf" 
 GraphView ::ID_CLICK_SPACE,
                VFLL15::VFLL10),


  FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_106 + 
#line 294 "gui.fxf" 
 GraphView ::ID_CLICK_NODE,
                VFLL15::VFLL12),


  FXMAPFUNC(SEL_COMMAND, VFLL15::YQRZ_106 + 
#line 294 "gui.fxf" 
 GraphView ::ID_DCLICK_NODE,
                VFLL15::VFLL14),


 }; 

 FXIMPLEMENT(VFLL15, FXMainWindow, YQRZ_111, ARRAYNUMBER(YQRZ_111))

 // FIXME: the argument names must be changed so that
 // we can have widgets called 'y' etc.
 VFLL15::VFLL15(
         FXApp* a,const FXString& name,
         FXIcon *ic,FXIcon *mi,FXuint opts,
         FXint x,FXint y,FXint w,FXint h,
         FXint pl,FXint pr,FXint pt,FXint pb,
         FXint hs,FXint vs) :
               FXMainWindow(a,name, ic,mi,opts,
                            x,y,w,h, pl,pr,pt,pb, hs,vs)

 {
   setTarget(this);
   setSelector(ID_SELF);
   
  FXVerticalFrame *YQRZ_110= new
    FXVerticalFrame( this,
        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        LAYOUT_FILL_X |
        LAYOUT_FILL_Y |
        0 |
        0 | 
        0 ,
        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_SPACING,
        DEFAULT_SPACING);


  FXHorizontalFrame *YQRZ_104= new
    FXHorizontalFrame( YQRZ_110,
        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        LAYOUT_FILL_X |
        0 |
        FRAME_THICK |
        0 | 
        0 ,
        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_SPACING,
        DEFAULT_SPACING);



  
#line 148 "gui.fxf" 
 PanArea  *YQRZ_1;
  YQRZ_1= scroller = 
#line 151 "gui.fxf" 

    new PanArea(YQRZ_104, this, YQRZ_2, LAYOUT_FILL_Y); 
    scroller->fg= FXRGB(0xdd,0xdd,0xdd);
    scroller->bg= FXRGB(0x00,0x00,0x00);
  


  FXVerticalFrame *YQRZ_51= new
    FXVerticalFrame( YQRZ_104,
        LAYOUT_LEFT |
        LAYOUT_CENTER_Y |
        LAYOUT_SIDE_TOP |
        0 |
        0 |
        0 |
        0 | 
        0 ,
        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        0,
        0);


  FXHorizontalFrame *YQRZ_18= new
    FXHorizontalFrame( YQRZ_51,
        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |
        0 |
        0 | 
        0 ,
        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        0,
        0,
        0,
        0);



  FXButton *YQRZ_3;

  YQRZ_3= color0 =
    new FXButton(YQRZ_18,
      "  ",
      NULL,
      this ,
      YQRZ_4 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

         | LAYOUT_FIX_WIDTH 
        
        ,

        0,0,20,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


    YQRZ_3->setBackColor(FXRGB(0xff,0x00,0x00)); 

         



  FXButton *YQRZ_8;

  YQRZ_8= color1 =
    new FXButton(YQRZ_18,
      "  ",
      NULL,
      this ,
      YQRZ_9 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

         | LAYOUT_FIX_WIDTH 
        
        ,

        0,0,20,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


    YQRZ_8->setBackColor(FXRGB(0xff,0x6b,0x8e)); 

         



  FXButton *YQRZ_13;

  YQRZ_13= color2 =
    new FXButton(YQRZ_18,
      "  ",
      NULL,
      this ,
      YQRZ_14 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

         | LAYOUT_FIX_WIDTH 
        
        ,

        0,0,20,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


    YQRZ_13->setBackColor(FXRGB(0x3c,0xff,0x36)); 

         


  FXHorizontalFrame *YQRZ_34= new
    FXHorizontalFrame( YQRZ_51,
        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |
        0 |
        0 | 
        0 ,
        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        0,
        0,
        0,
        0);



  FXButton *YQRZ_19;

  YQRZ_19= color3 =
    new FXButton(YQRZ_34,
      "  ",
      NULL,
      this ,
      YQRZ_20 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

         | LAYOUT_FIX_WIDTH 
        
        ,

        0,0,20,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


    YQRZ_19->setBackColor(FXRGB(0xaa,0xaa,0xaa)); 

         



  FXButton *YQRZ_24;

  YQRZ_24= color4 =
    new FXButton(YQRZ_34,
      "  ",
      NULL,
      this ,
      YQRZ_25 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

         | LAYOUT_FIX_WIDTH 
        
        ,

        0,0,20,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


    YQRZ_24->setBackColor(FXRGB(0xff,0x00,0xff)); 

         



  FXButton *YQRZ_29;

  YQRZ_29= color5 =
    new FXButton(YQRZ_34,
      "  ",
      NULL,
      this ,
      YQRZ_30 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

         | LAYOUT_FIX_WIDTH 
        
        ,

        0,0,20,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


    YQRZ_29->setBackColor(FXRGB(0xff,0xff,0x00)); 

         


  FXHorizontalFrame *YQRZ_50= new
    FXHorizontalFrame( YQRZ_51,
        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |
        0 |
        0 | 
        0 ,
        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        0,
        0,
        0,
        0);



  FXButton *YQRZ_35;

  YQRZ_35= color6 =
    new FXButton(YQRZ_50,
      "  ",
      NULL,
      this ,
      YQRZ_36 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

         | LAYOUT_FIX_WIDTH 
        
        ,

        0,0,20,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


    YQRZ_35->setBackColor(FXRGB(0xff,0x95,0x7d)); 

         



  FXButton *YQRZ_40;

  YQRZ_40= color7 =
    new FXButton(YQRZ_50,
      "  ",
      NULL,
      this ,
      YQRZ_41 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

         | LAYOUT_FIX_WIDTH 
        
        ,

        0,0,20,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


    YQRZ_40->setBackColor(FXRGB(0xfb,0x74,0xff)); 

         



  FXButton *YQRZ_45;

  YQRZ_45= color8 =
    new FXButton(YQRZ_50,
      "  ",
      NULL,
      this ,
      YQRZ_46 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

         | LAYOUT_FIX_WIDTH 
        
        ,

        0,0,20,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


    YQRZ_45->setBackColor(FXRGB(0x00,0xdd,0xdd)); 

         


  FXVerticalFrame *YQRZ_69= new
    FXVerticalFrame( YQRZ_104,
        LAYOUT_LEFT |
        LAYOUT_CENTER_Y |
        LAYOUT_SIDE_TOP |
        0 |
        0 |
        0 |
        0 | 
        PACK_UNIFORM_WIDTH ,
        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_SPACING,
        DEFAULT_SPACING);


  FXHorizontalFrame *YQRZ_57= new
    FXHorizontalFrame( YQRZ_69,
        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |
        0 |
        0 | 
        0 ,
        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_SPACING,
        DEFAULT_SPACING);



  FXButton *YQRZ_52;

  YQRZ_52= 
    new FXButton(YQRZ_57,
      "Delete",
      NULL,
      this ,
      YQRZ_53 ,

        LAYOUT_CENTER_X |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

        
        
        ,

        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


   

         


  FXHorizontalFrame *YQRZ_68= new
    FXHorizontalFrame( YQRZ_69,
        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        LAYOUT_FILL_X |
        0 |
        0 |
        0 | 
        PACK_UNIFORM_WIDTH ,
        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_SPACING,
        DEFAULT_SPACING);



  FXButton *YQRZ_58;

  YQRZ_58= 
    new FXButton(YQRZ_68,
      "Extend",
      NULL,
      this ,
      YQRZ_59 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        LAYOUT_FILL_X |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

        
        
        ,

        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


   

         



  FXButton *YQRZ_63;

  YQRZ_63= 
    new FXButton(YQRZ_68,
      "Shrink",
      NULL,
      this ,
      YQRZ_64 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        LAYOUT_FILL_X |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

        
        
        ,

        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


   

         


  FXVerticalFrame *YQRZ_92= new
    FXVerticalFrame( YQRZ_104,
        LAYOUT_LEFT |
        LAYOUT_CENTER_Y |
        LAYOUT_SIDE_TOP |
        0 |
        0 |
        0 |
        0 | 
        PACK_UNIFORM_WIDTH ,
        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_SPACING,
        DEFAULT_SPACING);


  FXHorizontalFrame *YQRZ_80= new
    FXHorizontalFrame( YQRZ_92,
        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        LAYOUT_FILL_X |
        0 |
        0 |
        0 | 
        PACK_UNIFORM_WIDTH ,
        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_SPACING,
        DEFAULT_SPACING);



  FXButton *YQRZ_70;

  YQRZ_70= 
    new FXButton(YQRZ_80,
      "Load",
      NULL,
      this ,
      YQRZ_71 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        LAYOUT_FILL_X |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

        
        
        ,

        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


   

         



  FXButton *YQRZ_75;

  YQRZ_75= 
    new FXButton(YQRZ_80,
      "New",
      NULL,
      this ,
      YQRZ_76 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        LAYOUT_FILL_X |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

        
        
        ,

        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


   

         


  FXHorizontalFrame *YQRZ_91= new
    FXHorizontalFrame( YQRZ_92,
        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        LAYOUT_FILL_X |
        0 |
        0 |
        0 | 
        PACK_UNIFORM_WIDTH ,
        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_SPACING,
        DEFAULT_SPACING);



  FXButton *YQRZ_81;

  YQRZ_81= 
    new FXButton(YQRZ_91,
      "Save",
      NULL,
      this ,
      YQRZ_82 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        LAYOUT_FILL_X |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

        
        
        ,

        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


   

         



  FXButton *YQRZ_86;

  YQRZ_86= 
    new FXButton(YQRZ_91,
      "SaveAs",
      NULL,
      this ,
      YQRZ_87 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        LAYOUT_FILL_X |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

        
        
        ,

        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


   

         


  FXVerticalFrame *YQRZ_103= new
    FXVerticalFrame( YQRZ_104,
        LAYOUT_RIGHT |
        LAYOUT_CENTER_Y |
        LAYOUT_SIDE_TOP |
        0 |
        0 |
        0 |
        0 | 
        PACK_UNIFORM_WIDTH ,
        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_SPACING,
        DEFAULT_SPACING);



  FXButton *YQRZ_93;

  YQRZ_93= 
    new FXButton(YQRZ_103,
      "Help",
      NULL,
      this ,
      YQRZ_94 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

        
        
        ,

        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


   

         



  FXButton *YQRZ_98;

  YQRZ_98= 
    new FXButton(YQRZ_103,
      "About",
      NULL,
      this ,
      YQRZ_99 ,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        0 |
        0 |

        FRAME_RAISED|FRAME_THICK |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y 

        

        
        
        ,

        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  


   

         



  
#line 294 "gui.fxf" 
 GraphView  *YQRZ_105;
  YQRZ_105= graph = 
#line 297 "gui.fxf" 

    new GraphView(YQRZ_110, this, YQRZ_106,
                  FRAME_RAISED | LAYOUT_FILL_X | LAYOUT_FILL_Y); 
    graph->scroller= scroller;
  



  FXLabel *YQRZ_107;

  YQRZ_107= status_bar =
    new FXLabel(YQRZ_110,
      "Welcome to Zooming Stickies",
      NULL,

        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        LAYOUT_FILL_X |
        0 |

        0 |
        ICON_BEFORE_TEXT |
        JUSTIFY_CENTER_X |
        JUSTIFY_CENTER_Y ,

        0,0,0,0, // x,y,w,h
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD,
        DEFAULT_PAD);

  

  

  

  



 }
 VFLL15:: ~ VFLL15() { }
 long VFLL15::handle_close
    (FXObject *object,FXSelector sel, void *arg)
 {
    
#line 332 "gui.fxf" 

   if (graph->modified && FXMessageBox::question(this, MBOX_YES_NO,
                "Confirm discarding of edited contents",
                "Current contents are not saved. \n"
                "Shall I still quit?")!=MBOX_CLICKED_YES)
     return 1;
  return 0;

    return 0;
 } 
 

long VFLL15::VFLL2 (FXObject *object,FXSelector sel, void *arg)
       { 
#line 157 "gui.fxf" 

    int *REQ= (int*) arg;
    graph->show_request(REQ[0], REQ[1]);
   return 1; }


long VFLL15::VFLL5 (FXObject *object,FXSelector sel, void *arg)
       { 
#line 162 "gui.fxf" 

    int *REQ= (int*) arg;
    graph->pan_request(REQ[0], REQ[1]);
   return 1; }



  long VFLL15::YQRZ_7
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 178 "gui.fxf" 
 color_button_click(graph, color0);  return 1; }





  long VFLL15::YQRZ_12
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 183 "gui.fxf" 
 color_button_click(graph, color1);  return 1; }





  long VFLL15::YQRZ_17
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 188 "gui.fxf" 
 color_button_click(graph, color2);  return 1; }





  long VFLL15::YQRZ_23
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 197 "gui.fxf" 
 color_button_click(graph, color3);  return 1; }





  long VFLL15::YQRZ_28
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 202 "gui.fxf" 
 color_button_click(graph, color4);  return 1; }





  long VFLL15::YQRZ_33
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 207 "gui.fxf" 
 color_button_click(graph, color5);  return 1; }





  long VFLL15::YQRZ_39
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 216 "gui.fxf" 
 color_button_click(graph, color6);  return 1; }





  long VFLL15::YQRZ_44
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 221 "gui.fxf" 
 color_button_click(graph, color7);  return 1; }





  long VFLL15::YQRZ_49
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 226 "gui.fxf" 
 color_button_click(graph, color8);  return 1; }





  long VFLL15::YQRZ_56
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 240 "gui.fxf" 

        if (graph->selected_box)
          graph->remove_box(graph->selected_box);
        return 1; }





  long VFLL15::YQRZ_62
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 253 "gui.fxf" 

        if (graph->selected_box)
          graph->rescale_box(graph->selected_box,1.1);
        return 1; }





  long VFLL15::YQRZ_67
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 262 "gui.fxf" 

        if (graph->selected_box)
          graph->rescale_box(graph->selected_box,0.9);
        return 1; }





  long VFLL15::YQRZ_74
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 274 "gui.fxf" 
 load_file(this,graph,status_bar);  return 1; }





  long VFLL15::YQRZ_79
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 275 "gui.fxf" 
 new_file(this,graph,status_bar);  return 1; }





  long VFLL15::YQRZ_85
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 278 "gui.fxf" 
 save_file(this,graph,status_bar);  return 1; }





  long VFLL15::YQRZ_90
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 279 "gui.fxf" 
 save_file_as(this,graph,status_bar);  return 1; }





  long VFLL15::YQRZ_97
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 286 "gui.fxf" 
 click_help();  return 1; }





  long VFLL15::YQRZ_102
    (FXObject *object,FXSelector sel, void *arg)
       { 
#line 287 "gui.fxf" 
 click_about();  return 1; }




long VFLL15::VFLL7 (FXObject *object,FXSelector sel, void *arg)
       { 
#line 303 "gui.fxf" 

   box_t *B;
   int *C= (int*) arg;
   B= graph->create_box(C[0], C[1], default_color, (char*) "Node" );
   graph->select_box(B);
   graph->edit_text(B);
   return 1; }


long VFLL15::VFLL10 (FXObject *object,FXSelector sel, void *arg)
       { 
#line 311 "gui.fxf" 

   graph->select_box(0);
   return 1; }



long VFLL15::VFLL12 (FXObject *object,FXSelector sel, void *arg)
       { 
#line 315 "gui.fxf" 

   graph->select_box((box_t*) arg);
   return 1; }



long VFLL15::VFLL14 (FXObject *object,FXSelector sel, void *arg)
       { 
#line 319 "gui.fxf" 

   graph->edit_text((box_t*) arg);
   return 1; }





 class VFLL16: public FXMainWindow
 {
  FXDECLARE(VFLL16)
 public:
  enum { ID_FIRST= FXMainWindow::ID_LAST,
         ID_SELF,
          };
  

  FXText *text;


  VFLL16(FXApp* a,const FXString& name,
         FXIcon *ic,FXIcon *mi,FXuint opts,
         FXint x,FXint y,FXint w,FXint h,
         FXint pl,FXint pr,FXint pt,FXint pb,
         FXint hs,FXint vs);
  virtual ~VFLL16();
  VFLL16() : FXMainWindow() { }
  long handle_close(FXObject *object,FXSelector sel, void *arg);
 };

 FXDEFMAP(VFLL16) YQRZ_115 []= {
  FXMAPFUNC(SEL_CLOSE, VFLL16::ID_SELF, VFLL16::handle_close),
  
 }; 

 FXIMPLEMENT(VFLL16, FXMainWindow, YQRZ_115, ARRAYNUMBER(YQRZ_115))

 // FIXME: the argument names must be changed so that
 // we can have widgets called 'y' etc.
 VFLL16::VFLL16(
         FXApp* a,const FXString& name,
         FXIcon *ic,FXIcon *mi,FXuint opts,
         FXint x,FXint y,FXint w,FXint h,
         FXint pl,FXint pr,FXint pt,FXint pb,
         FXint hs,FXint vs) :
               FXMainWindow(a,name, ic,mi,opts,
                            x,y,w,h, pl,pr,pt,pb, hs,vs)

 {
   setTarget(this);
   setSelector(ID_SELF);
   

  FXText *YQRZ_112;
  YQRZ_112= text = new FXText(
       this, NULL,0, // target & selector
        LAYOUT_LEFT |
        LAYOUT_TOP |
        LAYOUT_SIDE_TOP |
        LAYOUT_FILL_X |
        LAYOUT_FILL_Y |
        TEXT_WORDWRAP |
        VSCROLLER_ALWAYS |
        TEXT_READONLY | 
        0,
     0,0,0,0,  // x,y,w,h
             // FIXME: these are given as number constants in the
             // FXText constructor. Nothing symbolic like DEFAULT_PAD
             // etc. is used. So, I will do the same unwillingly.
     3,
     3,
     2,
     2);

  
     FXFontDesc YQRZ_113;
     YQRZ_112->getFont()->getFontDesc(YQRZ_113);
  

  

  
     strcpy(YQRZ_113.face, "Monospace");
  

  
    YQRZ_114= new FXFont(FXApp::instance(), YQRZ_113);
    YQRZ_112->setFont(YQRZ_114);
    
  



 }
 VFLL16:: ~ VFLL16() { }
 long VFLL16::handle_close
    (FXObject *object,FXSelector sel, void *arg)
 {
    /* window closing code would go here */
    return 0;
 } 
 



  

 gui_fracmain_t *gui_c_fracmain()
 {
    // ffo -> fox form object
    // ifo -> interface form object 
   VFLL15 *ffo;
   gui_fracmain_t * ifo;
   ffo= new VFLL15(
       FXApp::instance(),
       "Zooming Stickies",
       NULL, NULL, // FIXME: icons
       DECOR_ALL ,
       0, 0,
       640, 400,
       0, 0,
       0, 0,
       0, 0);
   // If the application has not been created, this will done
   // when the application gets created. Otherwise, we have
   // to explicitly do this.
   if (app_created) 
     ffo->create();
   
   ffo->show(PLACEMENT_SCREEN);

   ifo= (typeof(ifo)) malloc(sizeof(*ifo));
   ifo->self= ffo;
   
  
     ifo->scroller= ffo->scroller;
  

 ifo->color0.widget= ffo->color0;
 ifo->color0.cls= &gui_button_class;





 ifo->color1.widget= ffo->color1;
 ifo->color1.cls= &gui_button_class;




 ifo->color2.widget= ffo->color2;
 ifo->color2.cls= &gui_button_class;




 ifo->color3.widget= ffo->color3;
 ifo->color3.cls= &gui_button_class;




 ifo->color4.widget= ffo->color4;
 ifo->color4.cls= &gui_button_class;




 ifo->color5.widget= ffo->color5;
 ifo->color5.cls= &gui_button_class;




 ifo->color6.widget= ffo->color6;
 ifo->color6.cls= &gui_button_class;




 ifo->color7.widget= ffo->color7;
 ifo->color7.cls= &gui_button_class;




 ifo->color8.widget= ffo->color8;
 ifo->color8.cls= &gui_button_class;




 



 



 



 



 



 



 



 



 




  
     ifo->graph= ffo->graph;
  

 ifo->status_bar.widget= ffo->status_bar;
 ifo->status_bar.cls= &gui_label_class;




   return ifo;
 }


 

 gui_help_t *gui_c_help()
 {
    // ffo -> fox form object
    // ifo -> interface form object 
   VFLL16 *ffo;
   gui_help_t * ifo;
   ffo= new VFLL16(
       FXApp::instance(),
       "Help",
       NULL, NULL, // FIXME: icons
       DECOR_ALL ,
       0, 0,
       640, 400,
       0, 0,
       0, 0,
       0, 0);
   // If the application has not been created, this will done
   // when the application gets created. Otherwise, we have
   // to explicitly do this.
   if (app_created) 
     ffo->create();
   
   ffo->show(PLACEMENT_SCREEN);

   ifo= (typeof(ifo)) malloc(sizeof(*ifo));
   ifo->self= ffo;
   


  ifo->text.widget= ffo->text;
  ifo->text.cls= &gui_text_viewer_class;




   return ifo;
 }




static FXApp *app;

void gui_init(int *argc,char **argv)
{
  app= new FXApp("YAK", "KUT");
  app->init(*argc, argv);
  app->create();
    // YQRZ_114->create(); 
    
  app_created= 1;
}

void gui_run()
{
  app->run();
}

void gui_flush()
{
  app->runWhileEvents();
}


#line 357 "gui.fxf" 

  void graph_load_file(void *gp,const char *fn,void *sb)
  {
   char buf[2000];
   GraphView *v;
   FXLabel *s;
   FILE *f;
   v= (GraphView*) gp;
   f= fopen(fn, "rb");
   if (!f)
   {
    fprintf(stderr, "Can't read %s: %s.", fn, strerror(errno));
    exit(1);
   }
   v->load_file(f);
   fclose(f);
     v->modified= 0;
   s= (FXLabel*) sb;
     if (file_name) free(file_name);
     file_name= strdup(fn);
     snprintf(buf,sizeof(buf)-1,"File %s loaded.", file_name);
     s->setText(buf);
  }


