#line 185 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

#include <xincs.h>
#include <fxver.h>
#include <fxdefs.h>
#include <FXHash.h>
#include <FXThread.h>
#include <FXStream.h>
#include <FXString.h>
#include <FXRectangle.h>
#include <FXRegistry.h>
#include <FXApp.h>
#include <FXDCWindow.h>
#include "panarea.h"

using namespace FX;

#line 18 "panarea.cc"

static double dmin(double a, double b)
 ;
static double dmax(double a, double b)
 ;
#line 204 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"
// Needed for the mouse module
#define CLASSNAME PanArea

FXDEFMAP(PanArea) panareaEventMap[]={
#line 42 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"
  FXMAPFUNC(SEL_PAINT,0,PanArea::onPaint),

#line 10 "/home/dodo/PRG/zooming_stickies-1.0/src/mouse.u"

  FXMAPFUNC(SEL_LEFTBUTTONPRESS,0, CLASSNAME::onLeftBtnPress),
  FXMAPFUNC(SEL_LEFTBUTTONRELEASE,0, CLASSNAME::onLeftBtnRelease),
  FXMAPFUNC(SEL_MOTION,0, CLASSNAME::onMotion),

#line 209 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"
};

FXIMPLEMENT(PanArea,FXWindow,panareaEventMap,
            ARRAYNUMBER(panareaEventMap))

PanArea::PanArea(){ flags|=FLAG_ENABLED|FLAG_SHOWN; }

PanArea::PanArea
     (FXComposite* p, FXObject *tgt, int sel, FXuint opts,
     FXint x,FXint y,FXint w,FXint h):
            FXWindow(p,opts,x,y,w,h)
{
   flags|=FLAG_ENABLED|FLAG_SHOWN;
   target= tgt; message= sel;
#line 16 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

  DSx= 0; DSy= 0; DLx= 99; DLy= 99;
  WSx= 0; WSy= 0; WLx= 99; WLy= 99;
#line 32 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"
  bg= FXRGB(0x00,0x00,0x00);
  fg= FXRGB(0xff,0xff,0xff);
#line 30 "/home/dodo/PRG/zooming_stickies-1.0/src/mouse.u"

  last_mouse_x=0, last_mouse_y=0;
  click_mouse_x=0, click_mouse_y=0;
  mouse_down= 0;

#line 119 "/home/dodo/PRG/zooming_stickies-1.0/src/mouse.u"
 dragging= 0;

#line 224 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"
}


bool PanArea::canFocus() const { return false; }
int PanArea::getDefaultWidth() { return 100; }
int PanArea::getDefaultHeight() { return 100; }

//void PanArea::create() {printf("create!\n"); FXWindow::create(); }
//void PanArea::detach() { FXWindow::detach(); }
//void PanArea::layout() { printf("layout!\n"); FXWindow::layout(); }
PanArea::~PanArea() { }


#line 45 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

long PanArea::onPaint(FXObject* ob,FXSelector sel,void* ptr)
{
  FXEvent* event=(FXEvent*)ptr;
  FXDCWindow dc(this,event);
#if 0
  printf("paint D(%d,%d,%d,%d)  W(%d,%d,%d,%d)\n",
          DSx, DLx, DSy, DLy, 
          WSx, WLx, WSy, WLy);
#endif
#line 65 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

 double Hdoc, Wdoc, Hwin, Wwin;
 double min_x, min_y,max_x,max_y;

 min_x = dmin(DSx, WSx); min_y= dmin(DSy, WSy);
 max_x = dmax(DLx, WLx); max_y= dmax(DLy, WLy);

 double Wtotal= max_x-min_x, Htotal= max_y-min_y;

 double Hself, Wself;

 Hself= getHeight(); if (Hself<1) Hself= 1; 
 Wself= getWidth();  if (Wself<1) Wself= 1;

 double scale= dmin(Hself/Htotal, Wself/Wtotal);

 Hdoc= (double) DLy - DSy; if (Hdoc<1) Hdoc= 1;
 Wdoc= (double) DLx - DSx; if (Wdoc<1) Wdoc= 1;

 Hwin= (double) WLy - WSy; if (Hwin<1) Hwin= 1;
 Wwin= (double) WLx - WSx; if (Wwin<1) Wwin= 1;

#line 92 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

 int Hused, Wused, Xoffset, Yoffset;
 int Xwaste, Ywaste, Xtrail, Ytrail;

 Hused= Htotal * scale;
 Wused= Wtotal * scale;

 Ywaste= getHeight()- Hused;
 Xwaste= getWidth() - Wused;
 if (Ywaste)
 {
   Yoffset= Ywaste/2;
   Ytrail= Ywaste-Yoffset;
 }
 if (Xwaste)
 {
   Xoffset= Xwaste/2;
   Xtrail= Xwaste-Xoffset;
 }
#line 115 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"


 dc.setForeground(backColor);
 dc.fillRectangle(0,0, Wself, Hself);

 dc.setForeground(bg);
 dc.fillRectangle( Xoffset+ (DSx-min_x)*scale, Yoffset+ (DSy-min_y)*scale,
                   Wdoc*scale, Hdoc*scale);
 dc.setForeground(fg);
 dc.fillRectangle( Xoffset+ (WSx-min_x)*scale, Yoffset+ (WSy-min_y)*scale,
                   dmax(Wwin*scale,10), dmax(Hwin*scale,10));

#line 57 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"
  return 1;
}

#line 264 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

void PanArea::doubleclick_action(int x,int y) { } 

void PanArea::click_action
    (int event_x, int event_y)
{
#line 65 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

 double Hdoc, Wdoc, Hwin, Wwin;
 double min_x, min_y,max_x,max_y;

 min_x = dmin(DSx, WSx); min_y= dmin(DSy, WSy);
 max_x = dmax(DLx, WLx); max_y= dmax(DLy, WLy);

 double Wtotal= max_x-min_x, Htotal= max_y-min_y;

 double Hself, Wself;

 Hself= getHeight(); if (Hself<1) Hself= 1; 
 Wself= getWidth();  if (Wself<1) Wself= 1;

 double scale= dmin(Hself/Htotal, Wself/Wtotal);

 Hdoc= (double) DLy - DSy; if (Hdoc<1) Hdoc= 1;
 Wdoc= (double) DLx - DSx; if (Wdoc<1) Wdoc= 1;

 Hwin= (double) WLy - WSy; if (Hwin<1) Hwin= 1;
 Wwin= (double) WLx - WSx; if (Wwin<1) Wwin= 1;

#line 92 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

 int Hused, Wused, Xoffset, Yoffset;
 int Xwaste, Ywaste, Xtrail, Ytrail;

 Hused= Htotal * scale;
 Wused= Wtotal * scale;

 Ywaste= getHeight()- Hused;
 Xwaste= getWidth() - Wused;
 if (Ywaste)
 {
   Yoffset= Ywaste/2;
   Ytrail= Ywaste-Yoffset;
 }
 if (Xwaste)
 {
   Xoffset= Xwaste/2;
   Xtrail= Xwaste-Xoffset;
 }
#line 271 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

  int a[2];
  a[0]= (event_x - Xoffset)/scale+min_x;
  a[1]= (event_y - Yoffset)/scale+min_y;

  if (target)
      target->tryHandle(this, FXSEL(SEL_COMMAND,message+ID_SHOWREQ), a);
}
#line 284 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"
int PanArea::drag_start(int event_x,int event_y)
{
#line 65 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

 double Hdoc, Wdoc, Hwin, Wwin;
 double min_x, min_y,max_x,max_y;

 min_x = dmin(DSx, WSx); min_y= dmin(DSy, WSy);
 max_x = dmax(DLx, WLx); max_y= dmax(DLy, WLy);

 double Wtotal= max_x-min_x, Htotal= max_y-min_y;

 double Hself, Wself;

 Hself= getHeight(); if (Hself<1) Hself= 1; 
 Wself= getWidth();  if (Wself<1) Wself= 1;

 double scale= dmin(Hself/Htotal, Wself/Wtotal);

 Hdoc= (double) DLy - DSy; if (Hdoc<1) Hdoc= 1;
 Wdoc= (double) DLx - DSx; if (Wdoc<1) Wdoc= 1;

 Hwin= (double) WLy - WSy; if (Hwin<1) Hwin= 1;
 Wwin= (double) WLx - WSx; if (Wwin<1) Wwin= 1;

#line 92 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

 int Hused, Wused, Xoffset, Yoffset;
 int Xwaste, Ywaste, Xtrail, Ytrail;

 Hused= Htotal * scale;
 Wused= Wtotal * scale;

 Ywaste= getHeight()- Hused;
 Xwaste= getWidth() - Wused;
 if (Ywaste)
 {
   Yoffset= Ywaste/2;
   Ytrail= Ywaste-Yoffset;
 }
 if (Xwaste)
 {
   Xoffset= Xwaste/2;
   Xtrail= Xwaste-Xoffset;
 }
#line 287 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"
  double X= (event_x-Xoffset)/scale+min_x;
  double Y= (event_y-Yoffset)/scale+min_y;
  if (X>=WSx && X<=WLx && Y>=WSy && Y<=WLy) return 1;
  return 0;
}

void PanArea::motion_action(int old_x,int old_y, int new_x, int new_y)
{
#line 65 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

 double Hdoc, Wdoc, Hwin, Wwin;
 double min_x, min_y,max_x,max_y;

 min_x = dmin(DSx, WSx); min_y= dmin(DSy, WSy);
 max_x = dmax(DLx, WLx); max_y= dmax(DLy, WLy);

 double Wtotal= max_x-min_x, Htotal= max_y-min_y;

 double Hself, Wself;

 Hself= getHeight(); if (Hself<1) Hself= 1; 
 Wself= getWidth();  if (Wself<1) Wself= 1;

 double scale= dmin(Hself/Htotal, Wself/Wtotal);

 Hdoc= (double) DLy - DSy; if (Hdoc<1) Hdoc= 1;
 Wdoc= (double) DLx - DSx; if (Wdoc<1) Wdoc= 1;

 Hwin= (double) WLy - WSy; if (Hwin<1) Hwin= 1;
 Wwin= (double) WLx - WSx; if (Wwin<1) Wwin= 1;

#line 92 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

 int Hused, Wused, Xoffset, Yoffset;
 int Xwaste, Ywaste, Xtrail, Ytrail;

 Hused= Htotal * scale;
 Wused= Wtotal * scale;

 Ywaste= getHeight()- Hused;
 Xwaste= getWidth() - Wused;
 if (Ywaste)
 {
   Yoffset= Ywaste/2;
   Ytrail= Ywaste-Yoffset;
 }
 if (Xwaste)
 {
   Xoffset= Xwaste/2;
   Xtrail= Xwaste-Xoffset;
 }
#line 296 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

  int a[2];

  a[0]= (new_x-old_x)/scale;
  a[1]= (new_y-old_y)/scale;

  if (target)
      target->tryHandle(this, FXSEL(SEL_COMMAND,message+ID_PANREQ), a);
}

void PanArea::mouse_release_action() { }

#line 43 "/home/dodo/PRG/zooming_stickies-1.0/src/mouse.u"

long CLASSNAME::onLeftBtnPress(FXObject* ob,FXSelector sel,void* ptr)
{
  FXEvent *event= (FXEvent*) ptr;
  int event_x= event->win_x, event_y= event->win_y;

  mouse_down = 1;
  last_mouse_x= event_x; last_mouse_y= event_y;
  click_mouse_x= event_x; click_mouse_y= event_y;

  return 1;
}

#line 60 "/home/dodo/PRG/zooming_stickies-1.0/src/mouse.u"

long CLASSNAME::onLeftBtnRelease(FXObject* ob,FXSelector sel,void* ptr)
{

  FXEvent* event=(FXEvent*)ptr;
  int event_x= event->win_x, event_y= event->win_y;
  int far;

  int dx= event_x-click_mouse_x;
  int dy= event_y-click_mouse_y;

  far= (dx*dx+dy*dy) >= 25;

  if (!mouse_down) goto done;
  mouse_down= 0;

  if (!far && event->click_button==LEFTBUTTON && event->click_count==1) {
     click_action(event_x, event_y);
     goto done;
  }
  if (!far && event->click_button==LEFTBUTTON && event->click_count==2) {
     doubleclick_action(event_x, event_y);
     goto done;
  }
done:
  dragging= 0;
  mouse_release_action();
  return 1;
}

#line 94 "/home/dodo/PRG/zooming_stickies-1.0/src/mouse.u"

long CLASSNAME::onMotion(FXObject* ob,FXSelector sel,void* ptr)
{
  if (!mouse_down) return 1;
  FXEvent* event=(FXEvent*)ptr;
  int event_x= event->win_x, event_y= event->win_y;
  if (dragging==0) {
    if (drag_start(last_mouse_x, last_mouse_y))
      dragging= 1;
    else dragging= 2;
  }
  if (dragging==2) return 1;

  motion_action(last_mouse_x, last_mouse_y, event_x, event_y);

  last_mouse_x= event_x; last_mouse_y= event_y;

  return 1;
}

#line 137 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

static double dmin(double a, double b)
 { return a< b? a: b; }

static double dmax(double a, double b)
 { return a>b ? a: b; }

#line 239 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

